	org $1001-2
	dw  $1001

rand			= $C0

keyb_ptr		= $C4	; zeropage variable (16 bits)
keyb_lastkey		= $C6	; zeropage variable (8 bits)
keyb_repeatcnt		= $C7	; zeropage variable (8 bits)
keyb_shift		= $C8	; zeropage variable (8 bits)
keyb_repeat_init	= 20	; constant
keyb_repeat		= 4	; constant

col_dst			= $D0	; rendering variables
chr_dst			= $D2
chr_dst2		= $D4
num_src			= $D6
number_width		= $D8	; in pixels, for centering
number_height		= $D9
current_color		= $DA
current_number		= $DB	; temporary holder
menu_index		= current_number 
current_x		= $DC
operations_cnt		= $DD
operations_ptr		= $DE

operand1		= $E0	; index of the number selected (0-5), $FF = no selection
operand2		= $E1	; index of the number selected (0-5), $FF = no selection
operand1_ptr		= $E2
operand2_ptr		= $E4
operator		= $E6	; 0-4: selected, $FF = no selection
selection		= $E7	; 0-5: number $80-$84: operator
backup_ptr		= $E8
level			= $EA
game_mode		= $EB	; 0 = daily (5 levels), 1 = random (1 level)

si_curpos		= $EC
si_maxlen		= $ED	; maximum number of typed chars
si_space		= 0

MAX_MENU_ITEM		= 2

BACKGROUND_COLOR	= $71
FADED_TITLE_COLOR	= $31
DEFAULT_COLOR		= $01  
SELECTED_COLOR		= $45
SELECTION_COLOR		= $4D
ERROR_COLOR1		= $22
ERROR_COLOR2		= $52

numbers			= $0130
solution		= $0130+6*4
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

set16	macro zp, addr
	lda #addr & 255
	sta zp
	lda #addr >> 8
	sta zp+1
	endm

add16	macro zp, add_value
	lda zp
	clc
	adc #add_value
	sta zp
	bcc *+4
	inc zp+1
	endm

add16zp	macro zp, zp2
	lda zp
	clc
	adc zp2
	sta zp
	bcc *+4
	inc zp+1
	endm

sub16	macro zp, sub_value
	lda zp
	sec
	sbc #sub_value
	sta zp
	lda zp+1
	sbc #$00
	sta zp+1
	endm
	
start
	sei
	sta $ff3f
	;
	jsr InitRandom
	;
	lda #SND_OFF
	jsr sound_set
	;
	ldx #$FF
	lda $FF07
	and #$40
	beq pal1
	;
	lda #$07				; NTSC changes: raster is half the size
	sta raster_size_1+1
	sta raster_size_2+1
	;
	lda #raster_colors_top_ntsc & 255	; separate (smaller) color tables
	sta raster_table_1+1
	lda #raster_colors_top_ntsc >> 8
	sta raster_table_1+2
	lda #raster_colors_bot_ntsc & 255
	sta raster_table_2+1
	lda #raster_colors_bot_ntsc >> 8
	sta raster_table_2+2
	;
	lda #$A2				; different top rasterline IRQ position
	sta irq1_hi+1
	lda #$F9
	sta irq1_lo+1
	;
	ldx #$F8				; ntsc
pal1	lda #$35
	cpx $FF1D
	bne *-3
	sta $FF19
	sta $FF15
	;
	lda #$0B
	sta $FF06
	;
	jsr set_irq1
	;
	asl $FF09
	cli
	;
	lda $FF07
	and #$40
	ora #$88
	sta $FF07
	;
	lda $FF12
	and #$03
	sta $FF12
	lda #charset >> 8
	sta $FF13
	;
	lda #$00
	sta si_curpos
	lda #8
	sta si_maxlen
	;
	ldx #$00				; clear screen
il0	lda #$00
	sta $0C00,x
	sta $0C00+$100,x
	sta $0C00+$200,x
	sta $0C00+$300,x
	lda #DEFAULT_COLOR
	sta $0800,x
	sta $0800+$100,x
	sta $0800+$200,x
	sta $0800+$300,x
	inx
	bne il0
	;
	jsr sync
	lda #$1B
	sta $FF06
	cli
	;
	; ---
	;
menu	lda $0C1A				; check if screen needs to be cleared
	beq no_clear				; by looking for the vertical line on screen
	;
	jsr clear_screen			; clear screen
	;
no_clear
	jsr sync
	;
	; --- reset logo
	;
	lda #150
	sta sw_delay+1
	lda #$00
	sta sw_x+1
	lda #logo1 & 255
	sta swl2+1
	lda #logo1 >> 8
	sta swl2+2
	;
	ldx #$7F
men1	lda logo2,x
	sta charset+$80*8,x			; copy logo into charset
	dex
	bpl men1
	;
	ldx #$00
	lda #$80
men2	sta $0C00+15,x				; print logo on screen
	clc
	adc #$01
	sta $0C00+40+15,x
	clc
	adc #$01
	inx
	cpx #$08
	bne men2
	;
	ldx #13
men3	lda txt_title_1,x			; print title
	sta $0C00+40*3+12,x
	lda txt_title_2,x
	sta $0C00+40*4+12,x
	lda #FADED_TITLE_COLOR
	sta $0800+40*3+12,x
	sta $0800+40*4+12,x 
	dex
	bpl men3
	;
	ldx #17					; print 3 lines of menu
men4	lda txt_menu_1,x
	sta $0C00+40*10+10,x
	lda txt_menu_2,x
	sta $0C00+40*11+10,x
	lda txt_menu_3,x
	sta $0C00+40*12+10,x
	dex
	bpl men4
	;
	ldx #39
men5	lda txt_info,x				; print bottom info (instructions)
	sta $0C00+19*40,x
	lda txt_info+40,x
	sta $0C00+21*40,x
	lda txt_info+80,x
	sta $0C00+22*40,x
	lda txt_info+120,x
	sta $0C00+24*40,x
	;
	lda #FADED_TITLE_COLOR
	sta $0800+19*40,x
	sta $0800+21*40,x
	sta $0800+22*40,x
	sta $0800+24*40,x
	dex
	bpl men5
	;
	lda #$00
	sta menu_index
	jsr color_menu_selection
	;
menu_loop
	lda #menu_key_table & 255
	ldx #menu_key_table >> 8
	jmp keyboard
	
menu_frame_call	
	jsr color_menu_selection
	jsr swap_logo
null	rts

swap_logo
	dec sw_delay+1
sw_delay
	lda #150
	bne swx
	;
sw_x	lda #$00
	tay
	lda sw_delays,y
	sta sw_delay+1
	tya
	and #$07
	tax
	lda bits,x
	sta sw_bit+1
	eor #$FF
	sta sw_and+1
	;
	tya
	and #$F8
	asl a
	tax
	;
	ldy #$0F
swl2	lda logo1,x
sw_bit	and #$80
	sta swl1+1
	lda charset+$80*8,x
sw_and	and #$7F
swl1	ora #$00
	sta charset+$80*8,x
	inx
	dey
	bpl swl2
	;
	lda sw_x+1
	clc
	adc #$01
	cmp #64
	bne swl3
	;
	lda swl2+1
	eor #((logo1 & 255)^(logo2 & 255))
	sta swl2+1
	lda swl2+2
	eor #((logo1 >> 8)^(logo2 >> 8))
	sta swl2+2
	;
	lda #$00
swl3	sta sw_x+1
	;
swx	rts

menu_1
	lda #$00
	db $2C
menu_2
	lda #$01
	db $2C
menu_3
	lda #$02
menu_set
	pha
	jsr clear_menu_selection
	pla
	sta menu_index
	;
	jsr color_menu_selection
	;
	lda #SND_TICK
	jsr sound_set
	jmp menu_loop

menu_up
	lda menu_index
	sec
	sbc #$01
	bpl *+4
	lda #MAX_MENU_ITEM
	jmp menu_set

menu_down
	lda menu_index
	clc
	adc #$01
	cmp #MAX_MENU_ITEM+1
	bcc *+4
	lda #$00
	jmp menu_set

clear_menu_selection
	ldx #BACKGROUND_COLOR
	bne cms3

color_menu_selection
	inc color_menu_selection_counter+1
color_menu_selection_counter
	lda #$00
	and #$07
	bne menu_color
	;
	lda menu_color+1
	eor #($35 ^ $67)
	sta menu_color+1
	;
menu_color
	ldx #$35
	;
cms3	ldy menu_index
	lda menu_dst_lo,y
	sta chr_dst
	sta col_dst
	lda menu_dst_hi,y
	sta chr_dst+1
	and #$FB
	sta col_dst+1
	;
	ldy #$02
cms2	lda #$3A
	sta (chr_dst),y
	txa
	sta (col_dst),y
	dey
	bpl cms2
	;
	ldy #$19
cms4	lda #$3A
	sta (chr_dst),y
	txa
	sta (col_dst),y
	dey
	cpy #$16
	bne cms4
	rts

clear_screen
	ldx #12
	set16 col_dst, $0800
	set16 chr_dst, $0C00
	set16 col_dst+4, $0800+24*40
	set16 chr_dst+4, $0C00+24*40
	;
clear2	jsr sync
	ldy #39
clear1	lda #DEFAULT_COLOR
	sta (col_dst),y
	sta (col_dst+4),y
	lda #$00
	sta (chr_dst),y
	sta (chr_dst+4),y
	dey
	bpl clear1
	;
	add16 col_dst, 40
	add16 chr_dst, 40
	sub16 col_dst+4, 40
	sub16 chr_dst+4, 40
	;
	dex
	bpl clear2
	rts

DisplayString
	jsr swap_logo
	;
	ldx #$00
	ldy #$00
ds1	cpx #4
	beq ds4
	cpx #7
	bne ds2
	;
ds4	lda #"-"
	bne ds3
	;
ds2	lda si_string,y
	iny
ds3	sta $0C00+12*40+14,x
	lda #$47
	sta $0C00+13*40+14,x
	inx
	cpy si_maxlen
	bne ds1
	;
	lda #$00
	sta $0C00+12*40+14,x			; erase last position (cursor might be there)
	;
	inc si_cursor_flash_index+1
si_cursor_flash_index
	lda #$00
	and #$10
	beq dsx	
	;
	ldx si_curpos
	cpx #4
	bcc ds5
	inx
	cpx #7
	bcc ds5
	inx
ds5	lda #$7D
	sta $0C00+12*40+14,x
	;
dsx	rts

wait_for_key_release
	lda #$02				; wait for ALL keys to be released (except shift lock)
	sta $FD30
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wait_for_key_release
	;
wfkr1	lda #$FF
	sta $FD30
	lda #$FD
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wfkr1
	;
wfkr2	lda #$FF
	sta $FD30
	lda #$FB
	sta $FF08
	lda $FF08
	cmp #$FF
	bne wfkr2
	;
	rts

start_input
	jsr wait_for_key_release
	;
	ldx #17
si1	lda txt_enter_1,x
	sta $0C00+40*10+10,x
	lda txt_enter_1+18,x
	sta $0C00+40*11+10,x
	dex
	bpl si1
	;
	jsr StringInput
	;
	lda #$00
	sta level
	sta game_mode
	;
	ldx #$00
	jsr get_si_byte
	sta rand
	ldx #$02
	jsr get_si_byte
	sta rand+1
	ldx #$05
	jsr get_si_byte
	sta rand+2
	ldx #$08
	jsr get_si_byte
	sta rand+3
	;
	jsr clear_screen
	;
	jmp new_game

get_si_byte
	lda si_string,x
	and #$0F
	lsr a
	lsr a
	lsr a
	lsr a
	sta gsb1+1
	lda si_string+1,x
	and #$0F
gsb1	ora #$00
	rts

menu_select
	jsr clear_menu_selection
	;
	lda #SND_SELECT
	jsr sound_set
	;
	lda menu_index
	beq start_input
	cmp #$01
	beq new_random_game
	;
	ldx #$03
	jsr sync
	dex
	bpl *-4
	;
	ldx #$FF
	lda $FF07
	and #$40
	beq *+4
	ldx #$F8				; ntsc
	lda #$6E
	cpx $FF1D
	bne *-3
	sta $FF19
	;
	sei
	lda #$0B
	sta $FF06
	;
	ldx #$00
	lda #$20
res1	sta $0C00,x
	sta $0D00,x
	sta $0E00,x
	sta $0F00,x
	inx
	bne res1
	;
	jmp $FFF6

new_random_game
	jsr clear_screen
	;
	lda #$01
	sta game_mode				; game mode = 1 (random)
	;
new_game
	set16 col_dst, $081A			; draw vertical line
	set16 chr_dst, $0C1A
	;
	ldy #$00
	ldx #24
il2	lda #$51				; vertical line color
	sta (col_dst),y
	lda #$1B				; vertical line character
	sta (chr_dst),y
	;
	add16 col_dst, 40
	add16 chr_dst, 40
	dex
	bpl il2
	;
	ldx #24					; draw controls
contr1	lda controls,x
	sta $0C00 + 20 * 40,x
	lda controls + 1 * 25,x
	sta $0C00 + 21 * 40,x
	lda controls + 2 * 25,x
	sta $0C00 + 22 * 40,x
	lda controls + 3 * 25,x
	sta $0C00 + 23 * 40,x
	lda controls + 4 * 25,x
	sta $0C00 + 24 * 40,x
	dex
	bpl contr1
	;
	ldx #9
il3	lda txt_operations,x			; print "operations" header
	sta $0C44,x
	dex
	bpl il3
	;
	set16 chr_dst, $0C00 + 4 * 40 + 1	; clear numbers
	ldx #14
clr2	ldy #22
	lda #$00
clr1	sta (chr_dst),y
	dey
	bpl clr1
	add16 chr_dst,40
	dex
	bpl clr2
	;
	ldy #$06				; clear top number (solution)
	lda number_font_dst_lo,y
	sta chr_dst
	lda number_font_dst_hi,y
	sta chr_dst+1
	;
	ldy #10*8-1
	lda #$00
cc81	sta (chr_dst),y
	dey
	bpl cc81
	;
	lda operations_dst_lo
	sta operations_ptr
	lda operations_dst_hi
	sta operations_ptr+1
	;
	ldx #20
clr3	jsr clear_operations_line
	add16 operations_ptr, 40 
	dex
	bpl clr3
	;
	; ---
	;
	jsr sync
	ldx #18
il5	lda txt_preparing_puzzle,x		; write "preparing" message
	sta $0C00+10*40+3,x
	lda #DEFAULT_COLOR
	sta $0800+10*40+3,x
	dex
	bpl il5
	;
	jsr generate_puzzle
	;
	jsr sync
	;
	ldx #18
	lda #$00
il6	sta $0C00+10*40+3,x			; clear "preparing" message
	dex
	bpl il6
	;
	ldx #$04
il4	txa
	asl a
	clc
	adc #$20
	sta $0C0A,x				; print top number characters
	clc
	adc #$01
	sta $0C0A+40,x				; two rows
	dex
	bpl il4
	;
	ldy #$06
	jsr render_number			; print top number (solution)
	;
	lda #$FF
	sta operand1
	sta operand2
	sta operator
	;
	lda #$00
	sta operations_cnt
	;
	set16 backup_ptr, free_mem
	;
	lda #DEFAULT_COLOR
	sta current_color
	;
	ldy #$00
il1	sty current_number
	jsr sync
	jsr print_empty_circle
	ldy current_number
	jsr render_number
	ldy current_number
	iny
	cpy #$06
	bne il1
	;
	;
	; ---
	;
	lda #$00
	sta selection
	;
new_operation
	lda #DEFAULT_COLOR
	sta current_color
	;
	ldy operator
	bmi nop1
	;
	jsr color_operator			; clear the color
	lda #$FF				; and the selection
	sta operator
	;
nop1	ldy operand1
	bmi nop2
	;
	sty current_number
	lda #$FF
	sta operand1
	jsr print_empty_circle
	ldy current_number
	jsr render_number
	;
nop2	ldy operand2
	bmi nop3
	;
	sty current_number
	lda #$FF
	sta operand2
	jsr print_empty_circle
	ldy current_number
	jsr render_number
	;
nop3	;
	; --- check if player has won
	;
	set16 num_src, numbers
	;
	ldx #$05
nw2	ldy #$03
nw3	lda (num_src),y
	cmp numbers+6*4,y
	bne nw1
	dey
	bpl nw3
	;
	jmp won
	; 
nw1	;
	add16 num_src, 4
	dex
	bpl nw2
	;
	; ---
	;
game_loop
	lda #SELECTION_COLOR
	sta current_color
	lda #$FF
	sta flash_selection_counter+1
	;
	lda #game_key_table & 255
	ldx #game_key_table >> 8
	jmp keyboard

won
	ldx operations_cnt
	lda operations_dst_lo,x
	sta operations_ptr
	lda operations_dst_hi,x
	sta operations_ptr+1
	;
	ldy #9
won1	lda txt_excellent,y
	sta (operations_ptr),y
	dey
	bpl won1
	;
	lda #SND_WIN
	jsr sound_set
	;
	ldx #50
	jsr sync
	dex
	bpl *-4
	;
	lda game_mode
	cmp #$01
	beq won2
	;
	lda level
	cmp #$04
	beq won3
	;
	clc
	adc #$01
	sta level
	clc
	adc #$01
	ora #$30
	sta txt_leveldone_1+19
	;
	add16 operations_ptr, 80
	set16 num_src, txt_leveldone_1
	ldx #$01
w2	jsr print_side_line
	dex
	bpl w2
	;
won2	;
	jsr write_quit
	;
end_loop
	lda #end_key_table & 255
	ldx #end_key_table >> 8
	jmp keyboard
	;
	; ---
won3	;
	add16 operations_ptr, 80
	set16 num_src, txt_congrats
	ldx #$02
w4	jsr print_side_line
	dex
	bpl w4
	;
	jsr waitkey
	;
	jmp menu

print_side_line
	ldy #12
psl1	lda (num_src),y
	sta (operations_ptr),y
	dey
	bpl psl1
	add16 num_src, 13
	add16 operations_ptr, 40
	rts

irq1
	pha
	txa
	pha
	tya
	pha
	;
raster_size_1
	ldx #$0F
	ldy #$B4
raster_table_1
ir1	lda raster_colors_top,x
	cpy $FF1E
	bcs *-3
	sta $FF19
	sta $FF15
	dex
	bpl ir1
	;
	jsr sound_call
	;
	lda #irq2 & 255
	sta $FFFE
	lda #irq2 >> 8
	sta $FFFF
	lda #$A2
	sta $FF0A
	lda #$D3
	sta $FF0B
	;
	asl $FF09
	pla
	tay
	pla
	tax
	pla
	rti

irq2
	pha
	txa
	pha
	tya
	pha
	;
raster_size_2
	ldx #$0F
	ldy #$B4
raster_table_2
ir2	lda raster_colors_bot,x
	cpy $FF1E
	bcs *-3
	sta $FF19
	sta $FF15
	dex
	bpl ir2
	;
	jsr set_irq1
	;
	asl $FF09
	pla
	tay
	pla
	tax
	pla
	rti

set_irq1
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
irq1_hi	lda #$A3
	sta $FF0A
irq1_lo	lda #$24
	sta $FF0B
	rts

raster_colors_top
	db $71,$67,$71,$71,$67,$67,$71,$67
	db $67,$67,$35,$67,$67,$35,$35,$67
raster_colors_top_ntsc
	db $71,$67,$71,$67,$67,$35,$67,$35

raster_colors_bot
	db $35,$67,$35,$35,$67,$67,$35,$67
	db $67,$67,$71,$67,$67,$71,$71,$67
raster_colors_bot_ntsc
	db $35,$67,$35,$67,$67,$71,$67,$71

	include "key_constants.asm"
	include "keyboard.asm"
	include "string_input.asm"
	include "random.asm"
	include "sounds.asm"
	
flash_selection
	inc flash_selection_counter+1
flash_selection_counter
	lda #$00
	and #$03
	bne fs1
	;
;	lda flash_selection_counter+3
;	cmp #$1F
;	beq fs3
;	clc
;	adc #$01
;	asl a
;	sec
;	sbc #$01
;	sta flash_selection_counter+3 
	;
fs3	lda current_color
	eor #$10
	sta current_color
	lda selection
	bpl fs2
	;
	and #$7F
	tay
	jmp color_operator
	;
fs2	tay
	jsr color_circle
	;
fs1	rts

clear_selection
	lda selection
	bpl cls1
	;
	and #$7F
	tay
	cpy operator
	beq cls3
	lda #DEFAULT_COLOR
	db $2C
cls3	lda #SELECTED_COLOR
	sta current_color
	jmp color_operator
	;
cls1	tay					; check if it's selected
	cpy operand1
	beq cls2
	cpy operand2
	beq cls2
	;
	asl a					; check if it "exists"
	asl a
	tax
	lda numbers,x
	bmi cls4
	;
	lda #DEFAULT_COLOR
	db $2C
cls2	lda #SELECTED_COLOR
	db $2C
cls4	lda #BACKGROUND_COLOR
	sta current_color
	jmp color_circle

move_up
	jsr clear_selection
	;
	lda #SND_TICK
	jsr sound_set
	;
	lda selection
	bpl mvu1
	;
	and #$7F
	tax
	lda move_up_table_2,x
	jmp mvu2
	;
mvu1	tax
	lda move_up_table_1,x
mvu2	sta selection
	;
	jmp game_loop

move_up_table_1
	db $80,$82,$84,0,1,2
move_up_table_2
	db 3,3,4,5,5

move_down
	jsr clear_selection
	;
	lda #SND_TICK
	jsr sound_set
	;
	lda selection
	bpl mvd1
	;
	and #$7F
	tax
	lda move_down_table_2,x
	jmp mvd2
	;
mvd1	tax
	lda move_down_table_1,x
mvd2	sta selection
	;
	jmp game_loop

move_down_table_1
	db 3,4,5,$80,$82,$84
move_down_table_2
	db 0,0,1,2,2

move_left
	jsr clear_selection
	;
	lda #SND_TICK
	jsr sound_set
	;
	lda selection
	bpl mvl1
	;
	and #$7F
	tax
	lda move_left_table_2,x
	jmp mvl2
	;
mvl1	tax
	lda move_left_table_1,x
mvl2	sta selection
	;
	jmp game_loop

move_left_table_1
	db 2,0,1,5,3,4
move_left_table_2
	db $84,$80,$81,$82,$83

move_right
	jsr clear_selection
	;
	lda #SND_TICK
	jsr sound_set
	;
	lda selection
	bpl mvr1
	;
	and #$7F
	tax
	lda move_right_table_2,x
	jmp mvr2
	;
mvr1	tax
	lda move_right_table_1,x
mvr2	sta selection
	;
	jmp game_loop

move_right_table_1
	db 1,2,0,4,5,3
move_right_table_2
	db $81,$82,$83,$84,$80

move_1
	lda #$00
	db $2C
move_2
	lda #$01
	db $2C
move_3
	lda #$02
	db $2C
move_4
	lda #$03
	db $2C
move_5
	lda #$04
	db $2C
move_6
	lda #$05
	db $2C
move_op0
	lda #$80
	db $2C
move_op1
	lda #$81
	db $2C
move_op2
	lda #$82
	db $2C
move_op3
	lda #$83
	db $2C
move_op4
	lda #$84
	;
	pha
	jsr clear_selection
	;
	pla
	sta selection
	;
	lda #SND_TICK
	jsr sound_set				; continue to "select"
	;
do_select
	lda selection
	bmi sel1				; selection of an operator
	;
	asl a
	asl a
	tax
	lda numbers,x
	bmi sel2				; can't select non-existent number
	;
	ldx operator				; has an operator been selected?
	bpl sel3
	;
	lda operand1
	cmp selection				; already selected?
	bne sel6
	;
	jmp game_loop				; same number selected again, do nothing
	;
sel6	tay
	bmi sel5				; is there already a selection?
	;
	jsr sync
	lda #DEFAULT_COLOR
	sta current_color
	jsr print_empty_circle			; "unselect" previously selected number
	ldy operand1
	lda selection
	sta operand1
	jsr render_number
	;
sel5	lda selection
	sta operand1				; first number
	;
	lda #SND_SELECT
	jsr sound_set
	;
	jsr sync
	ldy operand1
	jsr print_filled_circle
	ldy operand1
	jsr render_number
	;
	jmp game_loop
	;
sel1	cmp #$80				; undo?
	bne sel4
	;
	jsr undo				; special handling
	;
	jmp new_operation
	;
sel4	ldx operand1				; is the first operand already selected?
	bmi sel2
	;
	ldy operator
	bmi sel8
	;
	lda #DEFAULT_COLOR
	sta current_color
	jsr color_operator
	;
sel8	lda selection
	and #$7F
	sta operator
	;
	lda #SND_SELECT
	jsr sound_set
	;
	jmp game_loop
	;
sel2	lda #SND_NOT_ALLOWED
	jsr sound_set
	jmp game_loop
	;
sel3	lda selection				; second number selected
	cmp operand1
	beq sel2
	;
	sta operand2
	;
	tay
	jsr print_filled_circle
	ldy operand2
	jsr render_number
	;
	; --- print operation on screen
	;
	jsr print_operation
	jsr save_backup
	;
	; ---
	;
	ldx operator
	lda operator_calls_lo,x
	sta operator_call+1
	lda operator_calls_hi,x
	sta operator_call+2
	;
operator_call
	jsr $FFFF
	bcs operation_failed
	;
	lda #$3A				; equals sign
	jsr print_operation_char
	jsr print_operand1
	;
	lda operand1				; select the first operand
	sta selection
	;
	lda #SND_SUCCESS
	jsr sound_set
	;
	jmp new_operation

operation_failed
	ldx #$04
of1	txa
	pha
	jsr sync
	;
	txa
	and #$01
	bne of3
	lda #ERROR_COLOR1
	db $2C
of3	lda #ERROR_COLOR2
	sta current_color
	ldy operand1
	jsr color_circle
	ldy operand2
	jsr color_circle
	ldy operator
	jsr color_operator
	;
	lda #SND_INVALID
	jsr sound_set
	;
	ldx #20
of2	jsr sync
	dex
	bpl of2
	;
	pla
	tax
	dex
	bpl of1
	;
	jsr undo
	;
	jmp new_operation
	
sync
	lda #$CA
	cmp $FF1D
	bne *-3
	cmp $FF1D
	beq *-3
	rts
	
print_operation
	ldx operations_cnt
	lda operations_dst_lo,x
	sta operations_ptr
	lda operations_dst_hi,x
	sta operations_ptr+1
	;
	jsr get_operand_pointers
	;
	jsr print_operand1
	;
	;lda #$00
	;jsr print_operation_char
	ldx operator
	lda operator_chars,x
	jsr print_operation_char
	;lda #$00
	;jsr print_operation_char
	;
	ldy #$00
po3	lda (operand2_ptr),y
	bne po4
	iny
	bne po3
po4	lda (operand2_ptr),y
	ora #$30
	jsr print_operation_char
	iny
	cpy #$04
	bne po4
	rts

print_operand1
	ldy #$00
po2	lda (operand1_ptr),y
	bne po1
	iny
	bne po2
po1	lda (operand1_ptr),y
	ora #$30
	jsr print_operation_char
	iny
	cpy #$04
	bne po1
	rts

print_operation_char
	sta poc1+1
	tya
	pha
	ldy #$00
poc1	lda #$00
	sta (operations_ptr),y
	pla
	tay
	add16 operations_ptr,1
	rts

save_backup
	inc operations_cnt
	;
	ldy #6*4-1
sb1	lda numbers,y
	sta (backup_ptr),y
	dey
	bpl sb1
	;
	add16 backup_ptr, 6*4
	rts

restore
	sub16 backup_ptr, 6*4
	;
	ldy #6*4-1
un1	lda (backup_ptr),y
	sta numbers,y 
	dey
	bpl un1
	rts

clear_operations_line
	ldy #12
	lda #$00
un3	sta (operations_ptr),y			; erase last operation from right side
	dey
	bpl un3
	rts

undo
	lda operations_cnt
	bne un2
	;
	; can't undo
	;
	lda #SND_NOT_ALLOWED
	jsr sound_set
	;
	rts
	;
un2	lda #SND_UNDO
	jsr sound_set
	;
	jsr restore
	;
	dec operations_cnt
	;
	ldx operations_cnt
	lda operations_dst_lo,x
	sta operations_ptr
	lda operations_dst_hi,x
	sta operations_ptr+1
	;
	jsr clear_operations_line
	;
	lda #$FF				; clear operands to make sure
	sta operand1				; numbers are rendered "not selected"
	sta operand2
	;
	ldy #$00
un4	sty current_number
	lda #DEFAULT_COLOR			; must set this each time
	sta current_color
	jsr sync
	jsr print_empty_circle
	ldy current_number
	jsr render_number
	ldy current_number
	iny
	cpy #$06
	bne un4
	;
	rts
	
write_quit
	ldx #12
gq1	lda txt_quit_1,x
	sta $0C00+21*40+27,x
	lda txt_quit_2,x
	sta $0C00+22*40+27,x
	lda txt_quit_3,x
	sta $0C00+23*40+27,x
	lda txt_quit_4,x
	sta $0C00+24*40+27,x
	dex
	bpl gq1
	rts

game_quit
	jsr wait_for_key_release
	;
	jsr sync
	jsr clear_selection
	;
	jsr write_quit
	;
gq2	lda #$BF
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10				; Query keyboard for ESC
	beq gq4
	;
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10				; Query keyboard for "Space"
	bne gq2
	;
	jsr wait_for_key_release
	;
	ldx #12
	lda #$00
gq3	sta $0C00+21*40+27,x
	sta $0C00+22*40+27,x
	sta $0C00+23*40+27,x
	sta $0C00+24*40+27,x
	dex
	bpl gq3
	;
	jmp game_loop

gq4	jmp menu

menu_key_table
	dw menu_frame_call
	;
	dw $0102, menu_up			; Joystick 1
	dw $0202, menu_down
	dw $8002, menu_select
	;
	dw $0104, menu_up			; Joystick 2
	dw $0204, menu_down 
	dw $4004, menu_select
	;
	dw KEY_CURSOR_UP, menu_up
	dw KEY_CURSOR_DOWN, menu_down
	;
	dw KEY_COLON, menu_up
	dw KEY_DOT, menu_down
	;
	dw KEY_CLEAR_HOME, menu_1
	dw KEY_1, menu_1
	dw KEY_2, menu_2
	dw KEY_3, menu_3
	;
	dw KEY_RETURN, menu_select
	dw KEY_SPACE, menu_select
	;
	dw KEY_S, toggle_sound_menu
	;
	dw 0

game_key_table
	dw flash_selection 
	;
	dw $0102, move_up			; Joystick 1
	dw $0202, move_down
	dw $0402, move_left
	dw $0802, move_right
	dw $8002, do_select
	;
	dw $0104, move_up			; Joystick 2
	dw $0204, move_down 
	dw $0404, move_left
	dw $0804, move_right
	dw $4004, do_select
	;
	dw KEY_CURSOR_UP, move_up
	dw KEY_CURSOR_DOWN, move_down
	dw KEY_CURSOR_LEFT, move_left
	dw KEY_CURSOR_RIGHT, move_right
	;
	dw KEY_COLON, move_up
	dw KEY_DOT, move_down
	dw KEY_Z, move_left
	dw KEY_X, move_right
	;
	dw KEY_CLEAR_HOME, move_1
	dw KEY_1, move_1
	dw KEY_2, move_2
	dw KEY_3, move_3
	dw KEY_4, move_4
	dw KEY_5, move_5
	dw KEY_6, move_6
	dw KEY_INST_DEL, move_op0
	dw KEY_PLUS, move_op1
	dw KEY_MINUS, move_op2
	dw KEY_STAR, move_op3
	dw KEY_SLASH, move_op4
	;
	dw KEY_RETURN, do_select
	dw KEY_SPACE, do_select
	;
	dw KEY_S, toggle_sound_game
	;
	dw KEY_ESC, game_quit
	;
	dw 0

end_key_table
	dw null
	;
	dw KEY_RETURN, new_game
	dw KEY_SPACE, new_game
	;
	dw KEY_ESC, menu
	;
	dw 0
	
toggle_sound_menu
	lda sound_enabled
	eor #$FF
	sta sound_enabled
	;
	bne ts1
	;
	lda #SND_SELECT
	jsr sound_set
	;
ts1	jmp menu_loop

toggle_sound_game
	lda sound_enabled
	eor #$FF
	sta sound_enabled
	;
	bne ts2
	;
	lda #SND_SELECT
	jsr sound_set
	;
ts2	jmp game_loop

	; y = number to render
render_number
	sty current_number
	;
	tya
	asl a					; *4
	asl a
	tax
	lda numbers,x				; does this number "exist"? ($FF = no)
	bpl rn1
	;
	ldy current_number			; erase the number completely from the charset
	lda number_font_dst_lo,y		; (so it's an empty circle, for "selection")
	sta chr_dst
	lda number_font_dst_hi,y
	sta chr_dst+1
	;
	ldy #3*8*7-1
rn2	lda empty_circle_background,y
	sta (chr_dst),y
	dey
	bne rn2
	sta (chr_dst),y				; we can "cheat" a bit; the last two bytes are the same
	;
	lda #BACKGROUND_COLOR			; erase it by coloring it the background color
	sta current_color
	ldy current_number
	jmp color_circle
	;
	; *** measure width
	;
rn1	lda #$00
	sta number_width
	tya
	asl a					; *4
	asl a
	tax
mw3	lda numbers,x				; check each digit to find "beginning" of number
	bne mw5
	inx
	txa
	and #$03
	bne mw3					; keep looping
	dex					; if we exited the loop, the number is zero
	;
mw5	lda number_width			; first?
	beq mw2
	inc number_width			; 
mw2	lda numbers,x
	tay
	lda digit_widths,y
	clc
	adc number_width
	sta number_width 
	;
mw1	inx
	txa
	and #$03
	bne mw5
	;
	; *** calculate x
	;
	lda #7*8				; 7 chars wide (total width - number width)/2
	ldy current_number
	cpy #$06				; 7th number is the top one (goal)
	bne mw4
	lda #5*8				; which is only 5 chars wide
mw4	sec
	sbc number_width
	lsr a
	sta current_x 
	;
	; *** clear chars
	; 
	ldy current_number
	lda number_font_dst_lo,y
	sta chr_dst
	lda number_font_dst_hi,y
	sta chr_dst+1
	;
	cpy #$06
	bne cc7
	;
	ldy #10*8-1
	lda #$00
cc8	sta (chr_dst),y
	dey
	bpl cc8
	bmi cc9
	;
cc7	cpy operand1				; should it be drawn inverted?
	beq cc5
	cpy operand2
	beq cc5
	;
	ldy #3*8*7-1
cc1	lda empty_circle_background,y
	sta (chr_dst),y
	dey
	bne cc1
	beq cc4					; always jump
	;
cc5	ldy #3*8*7-1
cc6	lda filled_circle_background,y
	sta (chr_dst),y
	dey
	bne cc6
cc4	sta (chr_dst),y				; we can "cheat" a bit; the last two bytes are the same
	;
	; *** call render_digit for each digit
	;
cc9	lda current_number
	asl a					; *4
	asl a
	tax
cc2	lda numbers,x				; check each digit to find "beginning" of number
	bne cc3
	inx
	txa
	and #$03
	bne cc2
	dex
cc3	ldy current_number
	lda numbers,x
	stx tmpx1+1
	ldx current_x
	jsr render_digit
	inc current_x				; 1 pixel space between numbers
tmpx1	ldx #$00
	inx
	txa
	and #$03
	bne cc3
	rts

waitkey
wk1	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10	; Query keyboard for "Space"
	bne wk1
wk2	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10	; Query keyboard for "Space"
	beq wk2
	rts

	; y = number to render to
	; x = x coord (in pixels)
	; a = digit to render
render_digit
	pha
	;
	cpy #$06
	bne rd1
	;
	lda number_font_dst_lo,y		; top number only (5 chars wide)
	sta chr_dst
	lda number_font_dst_hi,y
	sta chr_dst+1
	;
	txa
	lsr a
	lsr a
	lsr a
	tay
	lda mul16,y
	clc
	adc chr_dst
	sta chr_dst
	bcc *+4
	inc chr_dst+1
	;
	lda #16
	bne rd2					; always jump
	;
rd1	lda number_font_dst_lo,y		; numbers inside circle
	clc
	adc #$04				; 4 pixels down
	sta chr_dst
	lda number_font_dst_hi,y
	sta chr_dst+1
	;
	txa
	lsr a
	lsr a
	lsr a
	tay
	lda mul24,y
	clc
	adc chr_dst
	sta chr_dst
	bcc *+4
	inc chr_dst+1
	;
	lda #24
rd2	sta number_height
	;
	lda chr_dst
	clc
	adc number_height
	sta chr_dst2
	lda chr_dst+1
	adc #$00
	sta chr_dst2+1
	;
	txa
	and #$07
	tay
	lda render_calls_lo,y
	sta render_call+1
	lda render_calls_hi,y
	sta render_call+2
	;
	pla
	tay
	lda digit_widths,y			; move current_x ahead by width
	clc
	adc current_x
	sta current_x
	;
	lda digit_bitmap_src_lo,y
	sta num_src
	lda digit_bitmap_src_hi,y
	sta num_src+1
render_call
	jmp $FFFF

render_digit_0
	ldx #$01
rd01	ldy #$0F
rd02	lda (num_src),y
	eor (chr_dst),y
	sta (chr_dst),y
	dey
	bpl rd02
	;
	add16 num_src, 16
	add16zp chr_dst, number_height
	dex
	bpl rd01
	;
	rts

render_digit_7
	ldx #$01
rd11	ldy #$0F
rd12	lda (num_src),y
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	eor (chr_dst),y
	sta (chr_dst),y
	lda (num_src),y
	asl a
	eor (chr_dst2),y
	sta (chr_dst2),y
	dey
	bpl rd12
	add16 num_src, 16
	add16zp chr_dst, number_height
	add16zp chr_dst2, number_height
	dex
	bpl rd11
	;
	rts

render_digit_6
	ldx #$01
rd21	ldy #$0F
rd22	lda (num_src),y
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	eor (chr_dst),y
	sta (chr_dst),y
	lda (num_src),y
	asl a
	asl a
	eor (chr_dst2),y
	sta (chr_dst2),y
	dey
	bpl rd22
	add16 num_src, 16
	add16zp chr_dst, number_height
	add16zp chr_dst2, number_height
	dex
	bpl rd21
	;
	rts

render_digit_5
	ldx #$01
rd31	ldy #$0F
rd32	lda (num_src),y
	lsr a
	lsr a
	lsr a
	lsr a
	lsr a
	eor (chr_dst),y
	sta (chr_dst),y
	lda (num_src),y
	asl a
	asl a
	asl a
	eor (chr_dst2),y
	sta (chr_dst2),y
	dey
	bpl rd32
	add16 num_src, 16
	add16zp chr_dst, number_height
	add16zp chr_dst2, number_height
	dex
	bpl rd31
	;
	rts

render_digit_4
	ldx #$01
rd41	ldy #$0F
rd42	lda (num_src),y
	lsr a
	lsr a
	lsr a
	lsr a
	eor (chr_dst),y
	sta (chr_dst),y
	lda (num_src),y
	asl a
	asl a
	asl a
	asl a
	eor (chr_dst2),y
	sta (chr_dst2),y
	dey
	bpl rd42
	add16 num_src, 16
	add16zp chr_dst, number_height
	add16zp chr_dst2, number_height
	dex
	bpl rd41
	;
	rts

render_digit_3
	ldx #$01
rd51	ldy #$0F
rd52	lda (num_src),y
	lsr a
	lsr a
	lsr a
	eor (chr_dst),y
	sta (chr_dst),y
	lda (num_src),y
	asl a
	asl a
	asl a
	asl a
	asl a
	eor (chr_dst2),y
	sta (chr_dst2),y
	dey
	bpl rd52
	add16 num_src, 16
	add16zp chr_dst, number_height
	add16zp chr_dst2, number_height
	dex
	bpl rd51
	;
	rts

render_digit_2
	ldx #$01
rd61	ldy #$0F
rd62	lda (num_src),y
	lsr a
	lsr a
	eor (chr_dst),y
	sta (chr_dst),y
	lda (num_src),y
	asl a
	asl a
	asl a
	asl a
	asl a
	asl a
	eor (chr_dst2),y
	sta (chr_dst2),y
	dey
	bpl rd62
	add16 num_src, 16
	add16zp chr_dst, number_height
	add16zp chr_dst2, number_height
	dex
	bpl rd61
	;
	rts

render_digit_1
	ldx #$01
rd71	ldy #$0F
rd72	lda (num_src),y
	lsr a
	eor (chr_dst),y
	sta (chr_dst),y
	lda (num_src),y
	asl a
	asl a
	asl a
	asl a
	asl a
	asl a
	asl a
	eor (chr_dst2),y
	sta (chr_dst2),y
	dey
	bpl rd72
	add16 num_src, 16
	add16zp chr_dst, number_height
	add16zp chr_dst2, number_height
	dex
	bpl rd71
	;
	rts

	; y = index of operation to color
	; current_color = color to use
color_operator
	lda operator_screen_dst_lo,y
	sta col_dst
	lda operator_screen_dst_hi,y
	and #$FB
	sta col_dst+1
	;
	ldx #$04
cop2	ldy #$04
	lda current_color
cop1	sta (col_dst),y
	dey
	bpl cop1
	;
	add16 col_dst, 40
	;
	dex
	bpl cop2
	rts

	; y = index of circle to color
	; current_color = color to use
color_circle
	lda number_screen_dst_lo,y
	sta col_dst
	lda number_screen_dst_hi,y
	and #$FB
	sta col_dst+1
	;
	ldx #$06
ccr2	ldy #$06
	lda current_color
ccr1	sta (col_dst),y
	dey
	bpl ccr1
	;
	add16 col_dst, 40
	;
	dex
	bpl ccr2
	rts

	; y = index of circle to print
print_empty_circle
	lda number_screen_dst_lo,y
	sta chr_dst
	sta col_dst
	lda number_screen_dst_hi,y
	sta chr_dst+1
	and #$FB
	sta col_dst+1
	;
	lda number_chars,y
	sta number_char+1
	; 
	set16 num_src, empty_circle_chars
	jsr print_empty_circle_2		; draw top part (2 chars tall)
	;
	ldx #$00
pnc4	ldy #$00
	txa
	clc
number_char
	adc #$80
pnc3	sta (chr_dst),y				; draw middle part (unique chars for each circle)
	clc
	adc #$03
	iny
	cpy #7
	bne pnc3
	;
	add16 chr_dst, 40
	;
	ldy #6
	lda current_color
pnc5	sta (col_dst),y
	dey
	bpl pnc5
	;
	add16 col_dst, 40
	;
	inx
	cpx #3
	bne pnc4				; continue and draw bottom part (2 chars tall)
	;
print_empty_circle_2
	ldx #$01
pnc2	ldy #$06
pnc1	lda (num_src),y
	sta (chr_dst),y
	lda current_color
	sta (col_dst),y
	dey
	bpl pnc1
	;
	add16 num_src, 7
	add16 chr_dst, 40
	add16 col_dst, 40
	;
	dex
	bpl pnc2
	rts

	; y = index of circle to print
print_filled_circle
	lda number_screen_dst_lo,y
	sta chr_dst
	sta col_dst
	lda number_screen_dst_hi,y
	sta chr_dst+1
	and #$FB
	sta col_dst+1
	;
	set16 num_src, filled_circle_chars
	jsr print_empty_circle_2		; draw top part (2 chars tall)
	;
	ldx #$02
pfc2	ldy #$06
	lda current_color
pfc1	sta (col_dst),y
	dey
	bpl pfc1
	;
	add16 chr_dst, 40
	add16 col_dst, 40
	dex
	bpl pfc2
	;
	jmp print_empty_circle_2

get_operand_pointers
	lda operand1
	asl a
	asl a
	clc
	adc #numbers & 255
	sta operand1_ptr
	lda #numbers >> 8
	adc #$00
	sta operand1_ptr+1
	;
	lda operand2
	asl a
	asl a
	clc
	adc #numbers & 255
	sta operand2_ptr
	lda #numbers >> 8
	adc #$00
	sta operand2_ptr+1
	;
	rts

add_numbers
	jsr get_operand_pointers
	;
	ldx #$00				; clear carry
	;
	ldy #$03
an2	lda (operand1_ptr),y
	cpx #$00				; check if carry is set
	beq an3
	sec
	dex
	db $24
an3	clc
	adc (operand2_ptr),y
	cmp #10					; check for overflow
	bcc an1
	;
	inx					; set carry
	sbc #10
an1	sta (operand1_ptr),y
	;
	lda #$FF
	sta (operand2_ptr),y			; clear 2nd operand
	;
	dey
	bpl an2
	;
	cpx #$00
	beq an4
	;
	sec					; failed (overflow)
	rts
	;
an4	clc
	rts

subtract_numbers
	jsr get_operand_pointers
	;
	ldx #$00				; clear carry
	;
	ldy #$03
sn1	lda (operand1_ptr),y
	cpx #$00				; check if carry is set
	beq sn2
	clc
	dex
	db $24
sn2	sec
	sbc (operand2_ptr),y
	bpl sn3
	;
	inx					; set carry
	clc
	adc #10
sn3	sta (operand1_ptr),y
	;
	lda #$FF
	sta (operand2_ptr),y			; clear 2nd operand
	;
	dey
	bpl sn1
	;
	cpx #$00
	beq sn4
	;
	sec					; failed (would be negative)
	rts
	;
sn4	ldy #$00
	lda (operand1_ptr),y
	iny
	ora (operand1_ptr),y
	iny
	ora (operand1_ptr),y 
	iny
	ora (operand1_ptr),y 
	bne sn5 
	;
	sec					; failed (would be zero)
	rts
	;
sn5	clc
	rts

compare_smaller					; returns CARRY SET if operand1 < operand2
	ldy #$00
cs1	lda (operand1_ptr),y
	cmp (operand2_ptr),y
	beq cs_equal
	bcs cs_larger
	;
	sec
	rts
	;
cs_equal
	iny
	cpy #$04
	bne cs1
	;
cs_larger
	clc
	rts

swap_operands					; swaps operand1 & 2
	ldy #$03
so1	lda (operand1_ptr),y
	tax
	lda (operand2_ptr),y
	sta (operand1_ptr),y
	txa
	sta (operand2_ptr),y
	dey
	bpl so1
	rts

multiply_numbers
	jsr get_operand_pointers
	;
	jsr compare_smaller
	bcc mn_not_smaller
	;
	jsr swap_operands
	;
mn_not_smaller
	ldy #$03
mn1	lda (operand1_ptr),y			; copy operand1 to multiplier
	sta multiplier,y
	lda (operand2_ptr),y			; copy operand2 to counter
	sta counter,y
	lda #$FF
	sta (operand2_ptr),y 
	dey
	bpl mn1
	bmi mn5
	;
	; ---
	;
mn6	ldx #$00				; clear carry
	;
	ldy #$03
mn2	lda (operand1_ptr),y
	cpx #$00				; check if carry is set
	beq mn3
	sec
	dex
	db $24
mn3	clc
	adc multiplier,y
	cmp #10					; check for overflow
	bcc mn4
	;
	inx					; set carry
	sbc #10
mn4	sta (operand1_ptr),y
	;
	dey
	bpl mn2
	;
	cpx #$00
	beq mn5
	;
	sec					; failed (overflow, product too high)
	rts
	;
mn5	ldy #$03
mn8	lda counter,y
	sec
	sbc #$01
	bpl mn7
	;
	lda #9
	sta counter,y
	dey
	bpl mn8
	;
mn7	sta counter,y
	;
	lda counter
	ora counter+1
	ora counter+2
	ora counter+3
	bne mn6
	;
	clc
	rts

divide_numbers
	jsr get_operand_pointers
	;
	ldy #$03
dn0	lda (operand1_ptr),y			; copy operand1 to multiplier
	sta multiplier,y
	lda #$00
	sta counter,y				; clear counter
	dey
	bpl dn0
	;
	; ---
	;
dn1a	ldx #$00				; clear carry
	;
	ldy #$03
dn1	lda multiplier,y
	cpx #$00				; check if carry is set
	beq dn2
	clc
	dex
	db $24
dn2	sec
	sbc (operand2_ptr),y
	bpl dn3
	;
	inx					; set carry
	clc
	adc #10
dn3	sta multiplier,y
	;
	dey
	bpl dn1
	;
	cpx #$00
	beq dn4
	;
	sec					; failed (not divisible)
	rts
	;
dn4	ldy #$03				; increment counter
dn5	lda counter,y
	clc
	adc #$01
	cmp #10
	bne dn6
	;
	lda #0
	sta counter,y
	dey
	bpl dn5 
	;
dn6	sta counter,y
	;
	lda multiplier
	ora multiplier+1
	ora multiplier+2
	ora multiplier+3
	bne dn1a				; haven't reached zero yet, loop
	;
	ldy #$03
dn7	lda counter,y
	sta (operand1_ptr),y
	lda #$ff
	sta (operand2_ptr),y 
	dey
	bpl dn7
	;
	clc
	rts

generate_puzzle
	lda game_mode				; in "daily" mode, level is set
	beq gp0
nrg1	jsr GetRandom				; in random level mode, pick random level
	and #$07
	cmp #$05
	bcs nrg1
	sta level				; random level (0-4)
	;
gp0	ldx #7*4-1
	lda #$FF
gp1	sta numbers,x				; clear all number data
	dex
	bpl gp1
	;
	lda #$00
	sta counter
	sta counter+1
	;
	; ---
	;
	ldx #$00
	stx current_number
	;
gp2	jsr GetRandom				; generate a random number between 2-25
	and #$1F
	beq gp2
	cmp #$01
	beq gp2
	cmp #25
	bcs gp2
	;
	ldy #$00
gp4	cmp #10
	bcc gp3
	sbc #10
	iny
	bne gp4
gp3	sta counter+3				; stored on "counter"
	sty counter+2
	;
	; ---
	;
	ldx #$05				; check if the number already exists
	set16 num_src, numbers
gp7	ldy #$03
gp6	lda (num_src),y
	cmp counter,y
	bne gp5
	dey
	bpl gp6
	bmi gp2					; exists, generate another one
gp5	;
	add16 num_src, 4
	dex
	bpl gp7
	;
	ldx current_number			; it's unique, store it
	lda #$00
	sta numbers,x
	inx
	sta numbers,x
	inx
	lda counter+2
	sta numbers,x
	inx
	lda counter+3
	sta numbers,x
	inx
	stx current_number
	;
	cpx #6*4
	bne gp2					; check if we're done with all 6
	;
	; ---
	;
	set16 backup_ptr, free_mem		; 6 unique numbers generated, save them
	jsr save_backup
	;
gp13	jsr GetRandom
	and #$07
	beq gp13
	cmp #$06
	bcs gp13
	sta current_x
	;
gp10	jsr GetRandom				; generate two random operand indexes
	and #$07
	cmp #$06
	bcs gp10
	lda #$00
	sta operand1
	asl a
	asl a
	tax
	lda numbers,x				; make sure it exists
	bmi gp10
	;
gp11	jsr GetRandom
	and #$07
	cmp #$06
	bcs gp11
	cmp operand1
	beq gp11
	sta operand2
	asl a
	asl a
	tax
	lda numbers,x				; make sure it exists
	bmi gp11
	;
	jsr GetRandom				; generate random operator
	and #$03
	clc
	adc #$01
	tax
	lda operator_calls_lo,x
	sta op_call+1
	lda operator_calls_hi,x
	sta op_call+2
op_call
	jsr $FFFF
	bcc gp12
	;
gp14	jmp generate_puzzle
	;
gp12    dec current_x
	bne gp10
	;
	; ---
	;    
	ldx #$05				; check if there's an acceptable solution
	set16 num_src, numbers
gp16	lda level
	beq check_level_1
	;
check_level_2_3_4_5
	ldy #$00
	lda (num_src),y
	bmi chl1				; if this number doesn't exist, go to the next one
	bne chl1				; first digit must be zero
	iny
	lda (num_src),y
	cmp level
	bne chl1				; second digit must be the level
	iny
	iny
	lda (num_src),y
	beq chl1				; last digit cannot be zero, if so, we found a solution
	bne gp17
	;
check_level_1
	ldy #$00
	lda (num_src),y
	bmi chl1				; if this number doesn't exist, go to the next one
	bne chl1				; first digit must be zero
	iny
	lda (num_src),y
	bne chl1				; second digit also must be zero
	iny
	lda (num_src),y
	cmp #$05
	bcc chl1				; tens must be 5-9
	iny
	lda (num_src),y
	bne gp17				; last digit cannot be zero, if so, we found a solution
chl1	;
	add16 num_src, 4
	dex
	bpl gp16
	jmp generate_puzzle			; no acceptable solution found
	;
gp17	ldy #$03
gp18	lda (num_src),y				; copy solution
	sta solution,y
	dey
	bpl gp18
	;
	jsr restore
	;
	; ---
	;
	ldx #$00				; sort the numbers
srt3	lda #$00
	sta operand1
	;
srt2	lda operand1
	clc
	adc #$01
	sta operand2
	;
	jsr get_operand_pointers
	jsr compare_smaller
	bcs srt1
	;
	jsr swap_operands
	;
srt1	inc operand1
	lda operand1
	cmp #$05
	bne srt2
	;
	inx
	cpx #$04
	bne srt3
	;
	rts

operator_calls_lo
	db undo & 255
	db add_numbers & 255
	db subtract_numbers & 255
	db multiply_numbers & 255
	db divide_numbers & 255

operator_calls_hi
	db undo >> 8
	db add_numbers >> 8
	db subtract_numbers >> 8
	db multiply_numbers >> 8
	db divide_numbers >> 8

multiplier
	db 0,0,0,0
counter
	db 0,0,0,0

filled_circle_chars
	db $00,$1C,$1D,$62,$1E,$1F,$00
	db $3D,$62,$62,$62,$62,$62,$3E
	;
	db $3F,$62,$62,$62,$62,$62,$40
	db $00,$41,$42,$62,$43,$44,$00

empty_circle_chars
	db $00,$45,$46,$47,$48,$49,$00
	db $4A,$4B,$00,$00,$00,$4C,$4D
	;
	db $4E,$4F,$00,$00,$00,$50,$51
	db $00,$52,$53,$54,$55,$56,$00
	
controls
	db $57,$58,$59,$5A,$5B
	db $57,$58,$5C,$5A,$5B
	db $57,$58,$5C,$5A,$5B
	db $57,$58,$5C,$5A,$5B
	db $57,$58,$5C,$5A,$5B
	;
	db $5D,$5E,$5F,$60,$61
	db $5D,$62,$63,$62,$61
	db $5D,$62,$62,$62,$61
	db $5D,$64,$65,$66,$61
	db $5D,$62,$67,$62,$61
	;
	db $68,$69,$62,$6A,$6B
	db $68,$6C,$6D,$6E,$6B
	db $68,$6C,$6F,$6E,$6B
	db $68,$70,$00,$71,$6B
	db $68,$6C,$6F,$6E,$6B
	;
	db $72,$73,$74,$75,$76
	db $72,$62,$77,$62,$76
	db $72,$62,$62,$62,$76
	db $72,$78,$79,$7A,$76
	db $72,$62,$67,$62,$76
	;
	db $7B,$7C,$7D,$7E,$7F
	db $7B,$7C,$7D,$7E,$7F
	db $7B,$7C,$7D,$7E,$7F
	db $7B,$7C,$7D,$7E,$7F
	db $7B,$7C,$7D,$7E,$7F
	
operations_dst_lo
	db ($0C00 + 4 * 40 + 27) & 255
	db ($0C00 + 6 * 40 + 27) & 255
	db ($0C00 + 8 * 40 + 27) & 255
	db ($0C00 + 10 * 40 + 27) & 255
	db ($0C00 + 12 * 40 + 27) & 255
	db ($0C00 + 14 * 40 + 27) & 255

operations_dst_hi
	db ($0C00 + 4 * 40 + 27) >> 8
	db ($0C00 + 6 * 40 + 27) >> 8
	db ($0C00 + 8 * 40 + 27) >> 8
	db ($0C00 + 10 * 40 + 27) >> 8
	db ($0C00 + 12 * 40 + 27) >> 8
	db ($0C00 + 14 * 40 + 27) >> 8

operator_screen_dst_lo
	db ($0C00 + 20 * 40 + 0*5) & 255
	db ($0C00 + 20 * 40 + 1*5) & 255
	db ($0C00 + 20 * 40 + 2*5) & 255
	db ($0C00 + 20 * 40 + 3*5) & 255
	db ($0C00 + 20 * 40 + 4*5) & 255

operator_screen_dst_hi
	db ($0C00 + 20 * 40 + 0*5) >> 8
	db ($0C00 + 20 * 40 + 1*5) >> 8
	db ($0C00 + 20 * 40 + 2*5) >> 8
	db ($0C00 + 20 * 40 + 3*5) >> 8
	db ($0C00 + 20 * 40 + 4*5) >> 8
	
number_screen_dst_lo
	db ($0C00 + 4 * 40 + 1) & 255
	db ($0C00 + 4 * 40 + 9) & 255
	db ($0C00 + 4 * 40 + 17) & 255
	db ($0C00 + 12 * 40 + 1) & 255
	db ($0C00 + 12 * 40 + 9) & 255
	db ($0C00 + 12 * 40 + 17) & 255

number_screen_dst_hi
	db ($0C00 + 4 * 40 + 1) >> 8
	db ($0C00 + 4 * 40 + 9) >> 8
	db ($0C00 + 4 * 40 + 17) >> 8
	db ($0C00 + 12 * 40 + 1) >> 8
	db ($0C00 + 12 * 40 + 9) >> 8
	db ($0C00 + 12 * 40 + 17) >> 8

number_font_dst_lo
	db (charset + ($80+0*21) * 8) & 255
	db (charset + ($80+1*21) * 8) & 255 
	db (charset + ($80+2*21) * 8) & 255 
	db (charset + ($80+3*21) * 8) & 255
	db (charset + ($80+4*21) * 8) & 255
	db (charset + ($80+5*21) * 8) & 255
	db (charset + $20 * 8) & 255

number_font_dst_hi
	db (charset + ($80+0*21) * 8) >> 8
	db (charset + ($80+1*21) * 8) >> 8
	db (charset + ($80+2*21) * 8) >> 8
	db (charset + ($80+3*21) * 8) >> 8
	db (charset + ($80+4*21) * 8) >> 8
	db (charset + ($80+5*21) * 8) >> 8
	db (charset + $20 * 8) >> 8
	
render_calls_lo
	db render_digit_0 & 255
	db render_digit_1 & 255
	db render_digit_2 & 255
	db render_digit_3 & 255
	db render_digit_4 & 255
	db render_digit_5 & 255
	db render_digit_6 & 255
	db render_digit_7 & 255

render_calls_hi
	db render_digit_0 >> 8
	db render_digit_1 >> 8
	db render_digit_2 >> 8
	db render_digit_3 >> 8
	db render_digit_4 >> 8
	db render_digit_5 >> 8
	db render_digit_6 >> 8
	db render_digit_7 >> 8

number_chars
	db $80+0*21
	db $80+1*21
	db $80+2*21
	db $80+3*21
	db $80+4*21
	db $80+5*21
	db $80+6*21

mul16
	db 0,16,32,48,64,80,96
mul24
	db 0,24,48,72,96,120,144

operator_chars
	db $00,"+-*/"

	; widths of the large digits in pixels	
digit_widths
	db 10, 9, 10, 11, 11, 10, 10, 10, 10, 10
	
digit_bitmap_src_lo
	db digit0 & 255
	db digit1 & 255
	db digit2 & 255
	db digit3 & 255
	db digit4 & 255
	db digit5 & 255
	db digit6 & 255
	db digit7 & 255
	db digit8 & 255
	db digit9 & 255

digit_bitmap_src_hi
	db digit0 >> 8
	db digit1 >> 8
	db digit2 >> 8
	db digit3 >> 8
	db digit4 >> 8
	db digit5 >> 8
	db digit6 >> 8
	db digit7 >> 8
	db digit8 >> 8
	db digit9 >> 8

empty_circle_background	; 56*24 h none charset
	db $38,$38,$30,$70,$60,$60,$E0,$E0
	db $C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0
	db $E0,$E0,$60,$60,$70,$30,$38,$38
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $1C,$1C,$0C,$0E,$06,$06,$07,$07
	db $03,$03,$03,$03,$03,$03,$03,$03
	db $07,$07,$06,$06,$0E,$0C,$1C,$1C

filled_circle_background	; 56*24 h none charset
	db $3F,$3F,$3F,$7F,$7F,$7F,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$7F,$7F,$7F,$3F,$3F,$3F
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 	db $FC,$FC,$FC,$FE,$FE,$FE,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FE,$FE,$FE,$FC,$FC,$FC

digits	; 160*16 h none charset
digit0
	db $1E,$7F,$7F,$F3,$E1,$E1,$E1,$E1
	db $E1,$E1,$E1,$E1,$F3,$7F,$7F,$1E

	db $00,$80,$80,$C0,$C0,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0,$C0,$80,$80,$00

digit1
	db $1C,$3C,$7C,$FC,$DC,$9C,$1C,$1C
	db $1C,$1C,$1C,$1C,$1C,$FF,$FF,$FF

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$80,$80,$80

digit2
	db $3F,$7F,$FF,$F3,$E1,$01,$01,$03
	db $07,$0F,$1E,$3C,$78,$FF,$FF,$FF

	db $00,$80,$C0,$C0,$C0,$C0,$C0,$C0
	db $80,$00,$00,$00,$00,$C0,$C0,$C0
       
digit3
	db $1F,$7F,$FF,$F1,$E0,$01,$0F,$0F
	db $0F,$01,$00,$E0,$F1,$FF,$7F,$1F

	db $00,$C0,$E0,$E0,$E0,$E0,$C0,$80
	db $C0,$E0,$E0,$E0,$E0,$E0,$C0,$00

digit4
	db $07,$0F,$0F,$1F,$1F,$3B,$3B,$73
	db $73,$FF,$FF,$FF,$03,$03,$03,$03

	db $80,$80,$80,$80,$80,$80,$80,$80
	db $80,$E0,$E0,$E0,$80,$80,$80,$80


digit5
	db $3F,$3F,$3F,$38,$78,$7F,$7F,$7F
	db $73,$01,$01,$E1,$F3,$FF,$7F,$1E

	db $80,$80,$80,$00,$00,$00,$80,$C0
	db $C0,$C0,$C0,$C0,$C0,$C0,$80,$00

digit6
	db $3F,$7F,$7F,$F3,$E1,$E0,$EF,$FF
	db $FF,$F3,$E1,$E1,$F3,$7F,$7F,$3F

	db $00,$80,$80,$C0,$C0,$00,$00,$80
	db $C0,$C0,$C0,$C0,$C0,$80,$80,$00

digit7
	db $FF,$FF,$FF,$03,$03,$07,$0E,$0E
	db $1C,$1C,$1C,$18,$38,$38,$38,$38

	db $C0,$C0,$C0,$80,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

digit8
	db $3F,$7F,$F3,$E1,$E1,$F3,$7F,$7F
	db $3F,$77,$E3,$E1,$E1,$F3,$7F,$3E

	db $00,$80,$C0,$C0,$C0,$C0,$80,$00
	db $80,$C0,$C0,$C0,$C0,$C0,$80,$00

digit9
	db $3E,$7F,$7F,$F3,$E1,$E1,$F3,$7F
	db $7F,$3D,$01,$61,$E3,$7F,$7F,$3F

	db $00,$00,$80,$80,$C0,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0,$80,$80,$00,$00
	
bits
	db $80,$40,$20,$10,$08,$04,$02,$01

sw_delays
	db 1,1,1,1,1,1,1,1,1,1,1,30
	db 1,1,1,1,1,1,1,1,1,30
	db 1,1,1,1,1,1,1,1,1,1,30
	db 1,1,1,1,1,1,1,1,1,30
	db 1,1,1,1,1,1,1,1,1,1,30
	db 1,1,1,1,1,1,1,1,1,150
	
logo1 ; 64*16 h none charset
	db $0F,$3F,$3F,$79,$70,$70,$70,$70
	db $70,$70,$70,$70,$79,$3F,$3F,$0F

	db $01,$C3,$C7,$EF,$ED,$E9,$E1,$E1
	db $E1,$E1,$E1,$E1,$E1,$CF,$CF,$0F

	db $C0,$C1,$C1,$C3,$C3,$C3,$C3,$C3
	db $C3,$C3,$C3,$C3,$C3,$F9,$F9,$F8

	db $FC,$FE,$FE,$CF,$87,$80,$BC,$FE
	db $FF,$CF,$87,$87,$CF,$FE,$FE,$FC

	db $0E,$1E,$3E,$7E,$6E,$4E,$0E,$0E
	db $0E,$0E,$0E,$0E,$0E,$7F,$7F,$7F

	db $1F,$1F,$1F,$00,$00,$00,$01,$01
	db $03,$03,$03,$03,$07,$C7,$C7,$C7

	db $F8,$F8,$F8,$70,$61,$E1,$C1,$C1
	db $81,$80,$80,$03,$03,$03,$01,$00

	db $FE,$FE,$FE,$E0,$E0,$FC,$FE,$FF
	db $CF,$07,$07,$87,$CF,$FF,$FE,$78

logo2	; 64*16 h none charset
	db $FF,$FF,$FF,$71,$70,$70,$70,$70
	db $70,$70,$70,$70,$71,$FF,$FF,$FF

	db $0F,$CF,$CF,$E1,$E1,$E1,$E1,$E1
	db $E1,$E1,$E1,$E1,$E1,$CF,$CF,$0F

	db $F8,$F9,$F9,$C3,$C3,$C3,$C3,$C3
	db $C3,$C3,$C3,$C3,$C3,$F9,$F9,$F8

	db $FC,$FE,$FE,$CF,$87,$80,$BF,$BF
	db $BF,$87,$87,$87,$CF,$FE,$FE,$FC

	db $7F,$7F,$7F,$0E,$0E,$0E,$0E,$0E
	db $0E,$0E,$0E,$0E,$0E,$7F,$7F,$7F

	db $DF,$DF,$DF,$01,$01,$01,$01,$01
	db $01,$01,$01,$01,$01,$C1,$C1,$C1

	db $FC,$FD,$FF,$C3,$C3,$C3,$C3,$C1
	db $C0,$C0,$C0,$C3,$C3,$C3,$C1,$C0

	db $78,$FE,$FF,$CF,$87,$80,$F8,$FE
	db $7F,$07,$07,$87,$CF,$FF,$FE,$78
	
menu_dst_lo
	db ($0C00+10*40+6) & 255
	db ($0C00+11*40+6) & 255
	db ($0C00+12*40+6) & 255
menu_dst_hi
	db ($0C00+10*40+6) >> 8
	db ($0C00+11*40+6) >> 8
	db ($0C00+12*40+6) >> 8

	cmap " ",0
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap ".",$2E
	cmap "!",$3B
	cmap "'",$3C
txt_operations
	db "OPERATIONS"
txt_excellent
	db "EXCELLENT!"
txt_leveldone_1
	db "NEXT UP...   "
	db "LEVEL        "
txt_congrats
	db "WELL DONE!   "
	db "ALL 5 LEVELS "
	db "COMPLETED!   "
	
txt_preparing_puzzle
	db "PREPARING PUZZLE..."

txt_quit_1
	db "PRESS ESC    "
txt_quit_2
	db "TO QUIT      "
txt_quit_3
	db "OR SPACE     "
txt_quit_4
	db "TO CONTINUE  "

txt_title_1
	db "A  MATH PUZZLE"
txt_title_2
	db "BY CSABO, 2023"
txt_menu_1
	db "PLAY  DAILY PUZZLE"
txt_menu_2
	db "PLAY  RANDOM LEVEL"
txt_menu_3
	db "       QUIT       "

txt_enter_1
	db "ENTER TODAY'S DATE"
	db "    YYYY-MM-DD    "
	
si_string
	db "          "
	
	;   0123456789012345678901234567890123456789
txt_info
	db "  COMBINE NUMBERS TO REACH THE TARGET.  "
	db "ADD, SUBTRACT, MULTIPLY, AND DIVIDE ANY "
	db "OF THE SIX NUMBERS TO GET TO THE TARGET."
	db " YOU DON'T HAVE TO USE ALL THE NUMBERS. "
	cmap

	align $0800
	include "charset.asm"

free_mem
	db 0
;eof