square_ptr	= $F0
square_idx	= $F2
sound_enabled	= $F3	; 0 = enabled, $FF = disabled

SND_OFF		= $00
SND_TICK	= $01
SND_SELECT	= $02
SND_SUCCESS	= $03
SND_NOT_ALLOWED	= $04
SND_INVALID	= $05
SND_UNDO	= $06
SND_WIN		= $07

CMD_NOP		= $FE	; no operation (do nothing)
CMD_STOP	= $FF	; stop

square_ptr_lo
	db sound_stop & 255
	db sound_tick & 255
	db sound_select & 255
	db sound_success & 255
	db sound_not_allowed & 255
	db sound_invalid & 255
	db sound_undo & 255
	db sound_win & 255

square_ptr_hi
	db sound_stop >> 8
	db sound_tick >> 8   
	db sound_select >> 8
	db sound_success >> 8
	db sound_not_allowed >> 8
	db sound_invalid >> 8
	db sound_undo >> 8
	db sound_win >> 8
	
sound_set
	ldx sound_enabled		; disabled?
	bmi sss1			; do nothing
	;
	cmp #$00
	bne sound_set_square
	;
	sta $FF11
	;
sound_set_square
	tax
	;
	lda square_ptr_lo,x
	sta square_ptr
	lda square_ptr_hi,x
	sta square_ptr+1
	ldy #$00
	sty square_idx
	;
	cpx #SND_TICK			; special handing for "tick"
	bne sss1
	;
	inc *+4
	lda #$FF
	and #$07
	asl a
	tay
	lda sound_tick+4,y
	sta sound_tick+1
	lda sound_tick+5,y 
	sta sound_tick+2
	;
sss1	rts

sound_call
	ldy square_idx
	lda (square_ptr),y
	bpl sc1				; check high bit (set = command, not set = volume)
	;
	cmp #CMD_STOP
	bne sc2
	;
	lda #$00
	sta $FF11
	rts
	;
sc2	cmp #CMD_NOP
	beq sc5
	;
sc1	sta $FF11			; it's volume, next 2 bytes are frequency
	iny
	lda (square_ptr),y
	sta $FF0F
	iny
	lda (square_ptr),y
	sta $FF10
	;
sc5	iny
	sty square_idx
	;
sc5a	rts

sound_stop
	db CMD_STOP

sound_tick
	db $22, $37,$01
	db CMD_STOP

	dw $137,$1CA,$224,$286
	dw $29C,$286,$224,$1CA
	
sound_select
	db $24, $37,$01
	db $24, $37,$01
	db $23, $24,$02
	db $23, $24,$02
	db CMD_STOP

sound_success
	db $26, $9C,$02
	db $26, $9C,$02
	db $25, $E5,$02
	db $25, $E5,$02
	db $24, $12,$03
	db $24, $12,$03
	db CMD_STOP
	
sound_not_allowed
	db $25, $37,$01
	db $24, $37,$01
	db $23, $37,$01
	db $23, $FE,$03
	db $25, $10,$00
	db $24, $10,$00
	db $23, $10,$00
	db CMD_STOP
	
sound_invalid
	db $24, $37,$01
	db $24, $37,$01
	db $23, $10,$00
	db $23, $10,$00
	db CMD_STOP

sound_undo
	db $41, $E0,$03
	db $42, $D8,$03
	db $44, $D0,$03
	db $44, $C0,$03
	db $43, $B0,$03
	db $43, $A0,$03
	db $42, $90,$03
	db $41, $80,$03
	db CMD_STOP

sound_win
	db $26, $9C,$02
	db $26, $E5,$02
	db $25, $12,$03
	db $25, $9C,$02
	db $24, $E5,$02
	db $24, $12,$03
	db $23, $9C,$02
	db $22, $E5,$02
	db $21, $12,$03
	;
	db $26, $E5,$02
	db $26, $12,$03
	db $25, $4E,$03
	db $25, $E5,$02
	db $24, $12,$03
	db $24, $4E,$03
	db $23, $E5,$02
	db $22, $12,$03
	db $21, $4E,$03
	;
	db $26, $12,$03
	db $26, $4E,$03
	db $25, $73,$03
	db $25, $12,$03
	db $24, $4E,$03
	db $24, $73,$03
	db $23, $12,$03
	db $22, $4E,$03
	db $21, $73,$03
	;
	db $26, $4E,$03, CMD_NOP
	db $26, $73,$03, CMD_NOP
	db $25, $89,$03, CMD_NOP
	db $25, $4E,$03, CMD_NOP
	db $24, $73,$03, CMD_NOP
	db $24, $89,$03, CMD_NOP
	db $23, $4E,$03, CMD_NOP
	db $22, $73,$03, CMD_NOP
	db $21, $89,$03, CMD_NOP
	;
	db CMD_STOP
;eof